public abstract class Heuristica{

    private char simbolo; 

    //private char tabuleiro[] = new char[9];

    // Implemente a lgica da sua heurstica aqui.
    // Veja o exemplo abaixo de "heurstica aleatria", que gera um nmero
    // entre 0 e 19

    public int getHeuristica(int indice, char tabuleiro[]) {
        return -1;
    }

    public static boolean isVencedor(int pos, char simb, char tabuleiro[]){
        switch(pos){
            case 0: if ( (tabuleiro[1]==simb && tabuleiro[2]==simb) || (tabuleiro[3]==simb && tabuleiro[6]==simb) || (tabuleiro[4]==simb && tabuleiro[8]==simb) ) return true; break;
            case 1: if ( (tabuleiro[0]==simb && tabuleiro[2]==simb) || (tabuleiro[4]==simb && tabuleiro[7]==simb) ) return true; break;
            case 2: if ( (tabuleiro[0]==simb && tabuleiro[1]==simb) || (tabuleiro[5]==simb && tabuleiro[8]==simb) || (tabuleiro[4]==simb && tabuleiro[6]==simb) ) return true; break;
            case 3: if ( (tabuleiro[0]==simb && tabuleiro[6]==simb) || (tabuleiro[4]==simb && tabuleiro[5]==simb) ) return true; break;
            case 4: if ( (tabuleiro[1]==simb && tabuleiro[7]==simb) || (tabuleiro[3]==simb && tabuleiro[5]==simb) || (tabuleiro[0]==simb && tabuleiro[8]==simb) || (tabuleiro[2]==simb && tabuleiro[6]==simb) ) return true; break;
            case 5: if ( (tabuleiro[2]==simb && tabuleiro[8]==simb) || (tabuleiro[3]==simb && tabuleiro[4]==simb) ) return true; break;
            case 6: if ( (tabuleiro[0]==simb && tabuleiro[3]==simb) || (tabuleiro[7]==simb && tabuleiro[8]==simb) || (tabuleiro[2]==simb && tabuleiro[4]==simb) ) return true; break;
            case 7: if ( (tabuleiro[1]==simb && tabuleiro[4]==simb) || (tabuleiro[6]==simb && tabuleiro[8]==simb) ) return true; break;
            case 8: if ( (tabuleiro[2]==simb && tabuleiro[5]==simb) || (tabuleiro[6]==simb && tabuleiro[7]==simb) || (tabuleiro[0]==simb && tabuleiro[4]==simb) ) return true; break;
        }
        return false;    
    }

    public static void setTabuleiro(char tabu[], char pos0, char pos1, char pos2, char pos3, char pos4, char pos5, char pos6, char pos7, char pos8){
        tabu[0]=pos0;        tabu[1]=pos1;        tabu[2]=pos2;        tabu[3]=pos3;        tabu[4]=pos4;        tabu[5]=pos5;        tabu[6]=pos6;        tabu[7]=pos7;        tabu[8]=pos8;
    }


    private static boolean vaiEnforcar(int pos, char simb, char tabuleiro[]){
        int disponiveis[] = new int[9], nDisponiveis=0, resultado=0;
        char tabAux[] = new char[9];
        
        for (int i=0;i<9;i++){
            tabAux[i]=tabuleiro[i];
        }
        tabAux[pos]=simb;
        nDisponiveis = Heuristica.getIndicesDisponiveis(tabAux,disponiveis);
        for (int i=0;i<nDisponiveis;i++){
            if (isVencedor(disponiveis[i],simb,tabAux)) resultado++;
            if (resultado>1) return true;
        }
        return false;     
    }

    public static boolean isPerdedorNaJogadaSeguinte(int pos, char simb, char tabuleiro[]){
        int resultado=0, nDisponiveis=0, nDisponiveis2=0;
        char oponente = (simb=='X'?'0':'X');
        char tabAux[] = new char[9], tabAux2[] = new char[9];
        int disponiveis[] = new int[9], disponiveis2[] = new int[9];
        
        for (int i=0;i<9;i++){
            tabAux[i]=tabuleiro[i];
        }
        tabAux[pos]=simb;
        
        nDisponiveis = getIndicesDisponiveis(tabAux,disponiveis);
        
        //System.out.println("Numero de items disponiveis: " + nDisponiveis);
        //System.out.println("Sou o smbolo: " + simb);


        for (int i=0;i<nDisponiveis;i++){
            // se vou ganhar na seguinte, ento no sou perdedor na jogada seguinte
            //System.out.println("\nindice de item: " + disponiveis[i]);
            //System.out.println("is vencedor: " + isVencedor(disponiveis[i],simb,tabAux));
            //System.out.println("vai enforcar "+ oponente + ": " + vaiEnforcar(disponiveis[i],oponente,tabAux));
            if (isVencedor(disponiveis[i],simb,tabAux) && vaiEnforcar(disponiveis[i],oponente,tabAux)) return true;
            if (isVencedor(disponiveis[i],simb,tabAux) && !vaiEnforcar(disponiveis[i],oponente,tabAux)) return false;            
        }
        
        for (int i=0;i<nDisponiveis;i++){
            resultado =0;
            for (int j=0;j<9;j++){
                tabAux2[j]=tabAux[j];
            }
            tabAux2[disponiveis[i]]=oponente;
            nDisponiveis2 = getIndicesDisponiveis(tabAux2,disponiveis2);
            for (int k=0;k<nDisponiveis2;k++){
                if (isVencedor(disponiveis2[k],oponente,tabAux2)) resultado++;
            }
            if (resultado>1) return true;
        }
        return false;    
    }


    private static boolean perdi(int posicao, char oponente, char tabAux[]){
    int resultado=0;
        switch(posicao){
            case 0: if (tabAux[1]==oponente && tabAux[2]==oponente) resultado++; 
                    if (tabAux[3]==oponente && tabAux[6]==oponente)  resultado++;
                    if (tabAux[4]==oponente && tabAux[8]==oponente)  resultado++; break;
            case 1: if (tabAux[0]==oponente && tabAux[2]==oponente)  resultado++;
                    if (tabAux[4]==oponente && tabAux[7]==oponente)  resultado++; break;
            case 2: if (tabAux[0]==oponente && tabAux[2]==oponente)  resultado++;
                    if (tabAux[5]==oponente && tabAux[8]==oponente)  resultado++;
                    if (tabAux[4]==oponente && tabAux[6]==oponente)  resultado++; break;
            case 3: if (tabAux[0]==oponente && tabAux[6]==oponente)  resultado++;
                    if (tabAux[4]==oponente && tabAux[5]==oponente)  resultado++; break;
            case 4: if (tabAux[1]==oponente && tabAux[7]==oponente)  resultado++;
                    if (tabAux[3]==oponente && tabAux[5]==oponente)  resultado++;
                    if (tabAux[0]==oponente && tabAux[8]==oponente)  resultado++;
                    if (tabAux[2]==oponente && tabAux[6]==oponente)  resultado++; break;
            case 5: if (tabAux[2]==oponente && tabAux[8]==oponente)  resultado++;
                    if (tabAux[3]==oponente && tabAux[4]==oponente)  resultado++; break;
            case 6: if (tabAux[0]==oponente && tabAux[3]==oponente)  resultado++;
                    if (tabAux[7]==oponente && tabAux[8]==oponente)  resultado++;
                    if (tabAux[2]==oponente && tabAux[4]==oponente)  resultado++; break;
            case 7: if (tabAux[1]==oponente && tabAux[4]==oponente)  resultado++;
                    if (tabAux[6]==oponente && tabAux[8]==oponente)  resultado++; break;
            case 8: if (tabAux[2]==oponente && tabAux[5]==oponente)  resultado++;
                    if (tabAux[6]==oponente && tabAux[7]==oponente)  resultado++;
                    if (tabAux[0]==oponente && tabAux[4]==oponente)  resultado++; break;
        }
        if (resultado>1) return true;
        else return false;
    }

    
    public static boolean isDiagonal(int pos1, int pos2){
        if (pos1%2==1 || pos2%2==1) return false;   // se o n for mpar, ele no pode estar na diagonal
        if (pos1==pos2) return false;
        int maior = (pos1>pos2?pos1:pos2);
        int menor = (pos1<pos2?pos1:pos2);
        switch(menor){
            case 0: if (maior==4 || maior==8) return true; break;
            case 2: if (maior==4 || maior==6) return true; break;
            case 4: if (maior==8 || maior==6) return true; break;
        }
        return false;    
    }
    
    public static boolean isMesmaLinhaOuColuna(int pos1, int pos2){
        if (pos1==pos2) return false;
        int maior = (pos1>pos2?pos1:pos2);
        int menor = (pos1<pos2?pos1:pos2);
        switch(menor){
            case 0: if (maior==1 || maior==2 || maior==3 || maior==6) return true; break;
            case 1: if (maior==2 || maior==4 || maior==7) return true; break;
            case 2: if (maior==5 || maior==8) return true; break;
            case 3: if (maior==4 || maior==5 || maior==6) return true; break;
            case 4: if (maior==5 || maior==7) return true; break;
            case 5: if (maior==8) return true; break;
            case 6: if (maior==7 || maior==8) return true; break;
            case 7: if (maior==8) return true; break;
        }
        return false;           
        
    }
    
    public int indiceAleatorio(char tabuleiro[]){
        int disponiveis[] = new int[9];
        int nDisponiveis=0, indice;
        
        nDisponiveis = getIndicesDisponiveis(tabuleiro,disponiveis);
        
        indice = (int)(Math.random()*100)%nDisponiveis;
        return disponiveis[indice];
    }
    
    private static int getIndicesDisponiveis(char[] tabuleiro, int[] disponiveis)
    {
      // The hyphen indicates an empty position.
      int nDisponiveis = 0;
      int i = 0;

      for (i = 0; i < 9; i++)
      {
        if (tabuleiro[i] == '-')
        {
          disponiveis[nDisponiveis] = i;
          nDisponiveis++;
        }
      }
      return nDisponiveis;
    } // End of applet function getAvailableMoves()


    public int indiceDoMaior(char tabuleiro[]) {
        int maior=0,indice,h=0;
        int disponiveis[] = new int[9];
        int nDisponiveis=0;
        
        nDisponiveis = getIndicesDisponiveis(tabuleiro,disponiveis);
        
        if (nDisponiveis==0) return -1;
        else indice = disponiveis[0];	// inicializo o indice pra conter o 1 valor disponvel
        
        for (int i=0;i<nDisponiveis;i++){
            h = getHeuristica(disponiveis[i], tabuleiro);
            if (h>maior) {
                indice = disponiveis[i];
                maior = h;
            }
        }
        return indice;
    }

    public Heuristica(char simbolo){
        this.simbolo=simbolo;
    }

    public char getSimbolo() {
        return simbolo;
    }
    
    public static void main(String[] args) {
        char tabuleiro[] = {'0','-','-',
                            '-','X','-',
                            '-','-','0'
                            };
                            
        //System.out.println(vaiEnforcar(6,'0',tabuleiro));
        System.out.println(isPerdedorNaJogadaSeguinte(2,'X',tabuleiro));
    }
        

}
