public class Heuristica1 extends Heuristica {

    /**
     * Idia: 	(a) cada espao em branco na mesma linha ou coluna vale um ponto;
     *			(b) cada espao em branco na mesma diagonal vale 2 pontos
     *
     * @param indice - inteiro de uma posio (0..8) do jogo
     * @param tabuleiro - representa um vetor de 9 posies (0..8), sendo que a
     *                      posio vazia  representada por '-'
     * @return um inteiro, que representa a heurstica dessa posio
     * 
     * Dicas: 
     * (1) use os mtodos: 
     *          a) boolean Heuristica.isDiagonal(int i, int j) - para verificar 
     *             se i e j esto na mesma diagonal
     *          b) boolean Heuristica.isMesmaLinhaOuColuna(int i, int j) - para
     *             verificar se i e j esto na mesma linha ou coluna
     *          c) qualquer outro mtodo static de Heuristica
     * (2) cuidado:
     * 			a) no implemente mtodos na super classe (Heuristica), pois irei
     * 			    usar apenas a sua classe Heuristica1 para disputar a 'copa
     * 				do mundo'. Lembre-se, usarei a MINHA super classe (original),
     * 				que  comum a todos os 'times'	         
     */
    public int getHeuristica (int indice, char tabuleiro[]){
        int resultado=0;
        //char meuSimbolo = this.getSimbolo();
        //char simboloDoAdversario = meuSimbolo=='X'?'0':'X';
        for (int i=0;i<9;i++){
            if (Heuristica.isDiagonal(i,indice) && tabuleiro[i]=='-') resultado+=2;		// (a)
            if (Heuristica.isMesmaLinhaOuColuna(i,indice) && tabuleiro[i]=='-') resultado++;	// (b)
        }
        return resultado;
    }
	

    // Construtor
    public Heuristica1(char simbolo) {
        super(simbolo);
    }
    
    public static void main(String[] args) {
    	Heuristica1 h = new Heuristica1('X');
        char tabuleiro[] = {'0','-','-',
                			'-','X','-',
                			'-','-','0'
                						};
        System.out.println("testando a Heuristica1...");
        System.out.println(h.getHeuristica(1, tabuleiro));
    }
    
}
